=== debian/control ===
Source: sysrepo
Section: libs
Maintainer: Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.1.0
Build-Depends: cmake,
               debhelper-compat (= 12),
               doxygen,
               graphviz,
               libyang-cpp-dev (>= 1.0.182),
               libyang-dev (>= 1.0.182),
               pkg-config
Homepage: https://github.com/sysrepo/sysrepo

Package: sysrepo
Depends: libsysrepo5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Description: YANG-based configuration and operational state data store [tools]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the tools to work with schemas and configuration.

Package: sysrepo-doc
Depends: ${misc:Depends}
Section: doc
Architecture: all
Description: YANG-based configuration and operational state data store [docs]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the documentation.

Package: sysrepo-plugind
Depends: libsysrepo5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Description: YANG-based configuration and operational state data store [daemon]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the daemon for grouping sysrepo plugins.

Package: libsysrepo5
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Section: libs
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C library]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the shared C library.

Package: libsysrepo-dev
Depends: libsysrepo5 (= ${binary:Version}),
         libyang-dev (>= 1.0.182),
         ${misc:Depends},
         ${shlibs:Depends}
Section: libdevel
Architecture: any
Description: YANG-based configuration and operational state data store [C development]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the static C library and headers.

Package: libsysrepo-cpp5
Pre-Depends: ${misc:Pre-Depends}
Depends: libsysrepo5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: libs
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C++ library]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the shared C++ library.

Package: libsysrepo-cpp-dev
Depends: libsysrepo-cpp5 (= ${binary:Version}),
         libyang-cpp-dev (>= 1.0.182),
         ${misc:Depends},
         ${shlibs:Depends}
Section: libdevel
Architecture: any
Description: YANG-based configuration and operational state data store [C++ development]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the shared C++ library and headers.
